## dtkaudiomanager 1.0.3

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

cmake_minimum_required(VERSION 3.13)

# If do't define version number, specify the version number
set (VERSION "1.0.0" CACHE STRING "define project version")

set(BIN_NAME dtkaudiomanager)

project(${BIN_NAME}
    LANGUAGES CXX
    HOMEPAGE_URL https://github.com/linuxdeepin/dtkaudiomanager
    DESCRIPTION "Qt-based development library for audio manager on Deepin"
    VERSION ${VERSION}
)

# specify install dir
include(GNUInstallDirs)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED on)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -Wextra")
set(CMAKE_SHARED_LINKER_FLAGS ${CMAKE_SHARED_LINKER_FLAGS} "-Wl,--as-needed")
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(DAUDIO_MANAGER_PLUGIN_DIR ${CMAKE_INSTALL_FULL_LIBDIR}/${BIN_NAME}/plugins)
add_definitions(-DDAUDIO_MANAGER_PLUGIN_DIR="${DAUDIO_MANAGER_PLUGIN_DIR}")
# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(BUILD_TESTING ON)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -fno-omit-frame-pointer")
else ()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")
endif ()

find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core DBus)
find_package(Dtk REQUIRED COMPONENTS Core)

add_subdirectory(src)
add_subdirectory(dde-daemon-plugin)
add_subdirectory(examples)

set(BUILD_DOCS ON CACHE BOOL "Generate doxygen-based documentation")
find_package(Doxygen)
if (BUILD_DOCS AND DOXYGEN_FOUND)
    add_subdirectory(docs)
endif ()

# test
if (BUILD_TESTING)
   add_subdirectory(tests)
endif ()

# for pc file config
set(PC_LIBS_PRIVATE Qt${QT_VERSION_MAJOR}Core)
set(PC_REQ_PRIVATE)
set(PC_REQ_PUBLIC)

# config pkgconfig file
configure_file(misc/${BIN_NAME}.pc.in ${BIN_NAME}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${BIN_NAME}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
# config cmake file
configure_file(misc/${BIN_NAME}Config.cmake.in ${BIN_NAME}Config.cmake @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${BIN_NAME}Config.cmake DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${BIN_NAME})

# config qmake moudule file
set(DTK_MODULE ${BIN_NAME})
set(DTK_DEPS "core dbus")
set(QMKSPECS_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/mkspecs/modules" CACHE STRING "INSTALL DIR FOR qt pri files")
configure_file(misc/qt_lib_${BIN_NAME}.pri.in qt_lib_${BIN_NAME}.pri @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qt_lib_${BIN_NAME}.pri DESTINATION "${QMKSPECS_INSTALL_DIR}")

=== dde-daemon-plugin/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

set(BIN_NAME dtkaudiomanager-ddedaemon)

file(GLOB_RECURSE INCLUDE_PRIVATE_FILES
    "../include/daudioport_p.h"
    "../include/daudiocard_p.h"
    "../include/daudioplugin_p.h"
)
file(GLOB_RECURSE INCLUDE_FILES
    "./daudioport_daemon.h"
    "./daudiocard_daemon.h"
    "./daudioplugin_daemon.h"
    "./daudiomanager_daemon.h"
    "./daudiodevice_daemon.h"
    "./daudiostream_daemon.h"
    "./daemonhelpers.hpp"
)
file(GLOB_RECURSE SRCS
    "./daudioport_daemon.cpp"
    "./daudiocard_daemon.cpp"
    "./daudioplugin_daemon.cpp"
    "./daudiomanager_daemon.cpp"
    "./daudiodevice_daemon.cpp"
    "./daudiostream_daemon.cpp"
    "../src/dbus/*.h"
    "../src/dbus/*.cpp"
)

add_library(${BIN_NAME} SHARED
    ${INCLUDE_FILES}
    ${INCLUDE_PRIVATE_FILES}
    ${SRCS}
)

include_directories(../include)
include_directories(../src)

SET(LIBRARY_OUTPUT_PATH ../plugins)
set_target_properties(${BIN_NAME} PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR})

target_compile_definitions(${BIN_NAME} PRIVATE VERSION="${CMAKE_PROJECT_VERSION}")

target_include_directories(${BIN_NAME} PUBLIC
    ${DtkCore_INCLUDE_DIRS}
)

target_link_libraries(${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::DBus
    ${DtkCore_LIBRARIES}
)

install(TARGETS ${BIN_NAME} DESTINATION ${DAUDIO_MANAGER_PLUGIN_DIR})

=== docs/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later
#${CMAKE_INSTALL_DATAROOTDIR}/qt5/doc

set (QCH_INSTALL_DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/qt5/doc CACHE STRING "QCH install location")
set (DOXYGEN_GENERATE_HTML "YES" CACHE STRING "Doxygen HTML output")
set (DOXYGEN_GENERATE_XML "NO" CACHE STRING "Doxygen XML output")
set (DOXYGEN_GENERATE_QHP "YES" CACHE STRING "Doxygen QHP output")
set (DOXYGEN_FILE_PATTERNS *.cpp *.h *.md *.zh_CN.dox CACHE STRING "Doxygen File Patterns")
set(DOXYGEN_EXCLUDE_PATTERNS *_p.h)
set (DOXYGEN_PROJECT_NUMBER ${CMAKE_PROJECT_VERSION} CACHE STRING "") # Should be the same as this project is using.
set (DOXYGEN_EXTRACT_STATIC YES)
set (DOXYGEN_OUTPUT_LANGUAGE "Chinese")
set (DOXYGEN_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/docs/)
set (DOXYGEN_QHG_LOCATION "qhelpgenerator")
set (DOXYGEN_QHP_NAMESPACE "org.deepin.dde.${CMAKE_PROJECT_NAME}")
set (DOXYGEN_QCH_FILE "${CMAKE_PROJECT_NAME}.qch")
set (DOXYGEN_QHP_VIRTUAL_FOLDER ${CMAKE_PROJECT_NAME})
set (DOXYGEN_HTML_EXTRA_STYLESHEET "" CACHE STRING "Doxygen custom stylesheet for HTML output")
set (DOXYGEN_TAGFILES "qtcore.tags=qthelp://doc.qt.io/qt-5/" CACHE STRING "Doxygen tag files")
set (DOXYGEN_MACRO_EXPANSION "YES")
set (DOXYGEN_EXPAND_ONLY_PREDEF "YES")
set (DOXYGEN_PREDEFINED
    "DAUDIOMANAGER_BEGIN_NAMESPACE=namespace Dtk { namespace AudioManager {"
    "DAUDIOMANAGER_END_NAMESPACE=}}"
    "DAUDIOMANAGER_USE_NAMESPACE=using namespace Dtk::AudioManager;"
)

if(BUILD_THEME)
set (DOXYGEN_HTML_EXTRA_STYLESHEET "../doxygentheme/doxygen-awesome.css"
                                "../doxygentheme/doxygen-awesome-sidebar-only.css"
                                "../doxygentheme/doxygen-awesome-sidebar-only-darkmode-toggle.css"
                                )
set (DOXYGEN_HTML_EXTRA_FILES "../doxygentheme/doxygen-awesome-darkmode-toggle.js"
                            "../doxygentheme/doxygen-awesome-fragment-copy-button.js"
                            "../doxygentheme/doxygen-awesome-paragraph-link.js"
                            "../doxygentheme/doxygen-awesome-interactive-toc.js"
                            )
set (DOXYGEN_GENERATE_TREEVIEW "YES")
set (DOXYGEN_DISABLE_INDEX "NO")
set (DOXYGEN_FULL_SIDEBAR "NO")
set (DOXYGEN_HTML_HEADER "../doxygentheme/header.html")
endif()

doxygen_add_docs (doxygen
    ${CMAKE_CURRENT_SOURCE_DIR}/../include
    ${CMAKE_CURRENT_SOURCE_DIR}/../docs
    ALL
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../
    COMMENT "Generate documentation via Doxygen"
)

install (FILES ${CMAKE_CURRENT_BINARY_DIR}/html/${CMAKE_PROJECT_NAME}.qch DESTINATION ${QCH_INSTALL_DESTINATION})

=== examples/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

include_directories(../include)
file(GLOB_RECURSE SRCS "*.h" "*.cpp")

set(EXECUTABLE_OUTPUT_PATH ../)
add_executable(dtkaudiomanager-example
    ${SRCS}
)

target_link_libraries(dtkaudiomanager-example PRIVATE
    ${BIN_NAME}
    Qt${QT_VERSION_MAJOR}::Core
)

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

set(BIN_NAME ${CMAKE_PROJECT_NAME})

file(GLOB_RECURSE INCLUDE_PRIVATE_FILES
    "../include/daudioport_p.h"
    "../include/daudiocard_p.h"
    "../include/daudiomanager_p.h"
    "../include/daudiodevice_p.h"
    "../include/daudiostream_p.h"
    "../include/daudiofactory_p.h"
    "../include/daudioplugin_p.h"
)
file(GLOB_RECURSE INCLUDE_FILES
    "../include/DAudioPort"
    "../include/DAudioCard"
    "../include/DAudioManager"
    "../include/DAudioDevice"
    "../include/DAudioStream"
    "../include/dtkaudiomanager_global.h"
    "../include/daudioport.h"
    "../include/daudiocard.h"
    "../include/daudiomanager.h"
    "../include/daudiodevice.h"
    "../include/daudiostream.h"
)
file(GLOB_RECURSE SRCS
    "./daudioport.cpp"
    "./daudiocard.cpp"
    "./daudiofactory.cpp"
    "./daudioplugin.cpp"
    "./daudiomanager.cpp"
    "./daudiodevice.cpp"
    "./daudiostream.cpp"
    "./dbus/*.h"
    "./dbus/*.cpp"
)

add_library(${BIN_NAME} SHARED
    ${INCLUDE_FILES}
    ${INCLUDE_PRIVATE_FILES}
    ${SRCS}
)

include_directories(../include)

add_definitions(-DLIBDTKAUDIOMANAGER_LIBRARY)

set_target_properties(${BIN_NAME} PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR})

target_compile_definitions(${BIN_NAME} PRIVATE VERSION="${CMAKE_PROJECT_VERSION}")

target_include_directories(${BIN_NAME} PUBLIC
    ${DtkCore_INCLUDE_DIRS}
)

target_link_libraries(${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::DBus
    ${DtkCore_LIBRARIES}
)

install(FILES ${INCLUDE_FILES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${BIN_NAME})
install(TARGETS ${BIN_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

set(BIN_NAME ut-dtkaudiomanager)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-access-control -fno-inline -Wno-pmf-conversions")

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Test)

add_definitions(-DUSE_FAKE_INTERFACE)

file(GLOB_RECURSE INCLUDE_FILES "../include/*.h")
file(GLOB_RECURSE SRCS
    "../src/*.h"
    "../src/*.cpp"
    "../dde-daemon-plugin/*.h"
    "../dde-daemon-plugin/*.cpp"
    "./fakedbus/daemonaudiomanagerservice.h"
    "./fakedbus/daemonaudiomanagerservice.cpp"
)
file(GLOB TEST_FILES
    "./main.cpp"
    "./ut-daudiohelpers.hpp"
    "./ut-daudioport.cpp"
    "./ut-daudiocard.cpp"
    "./ut-daudiodevice.cpp"
    "./ut-daudiostream.cpp"
    "./ut-daudiomanager.cpp"
    "./ut-ddaemonaudiomanager.cpp"
)

include_directories(
    "../include"
    "../dde-daemon-plugin"
    "../src"
)

add_executable(${BIN_NAME}
    ${INCLUDE_FILES}
    ${SRCS}
    ${TEST_FILES}
)

target_include_directories(${BIN_NAME} PUBLIC
    ${DtkCore_INCLUDE_DIRS}
)

target_link_libraries(${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::DBus
    Qt${QT_VERSION_MAJOR}::Test
    ${DtkCore_LIBRARIES}
    -lpthread
    -lgcov
    -lgtest
)

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    target_compile_options(${BIN_NAME} PRIVATE -fprofile-instr-generate -ftest-coverage)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_compile_options(${BIN_NAME} PRIVATE -fprofile-arcs -ftest-coverage)
endif()

enable_testing()
add_test(NAME ${BIN_NAME} COMMAND ${BIN_NAME})

=== debian/changelog ===
dtkaudiomanager (1.0.3-1) unstable; urgency=medium

  * update

 -- Packages Builder <packages@deepin.com>  Tue, 17 Jan 2023 13:48:03 +0800

dtkaudiomanager (1.0.3) unstable; urgency=medium

  * master 1.0.3

 -- Deepin Packages Builder <packages@deepin.com>  Tue, 17 Jan 2023 13:36:40 +0800

dtkaudiomanager (1.0.0) unstable; urgency=medium

  * Initial release

 -- Deepin Packages Builder <packages@deepin.com>  Fri, 01 Jul 2022 14:29:07 +0800

=== debian/control ===
Source: dtkaudiomanager
Section: libdevel
Priority: optional
Maintainer: Packages Builder <packages@deepin.com>
Build-Depends:
 debhelper-compat (= 12),
 cmake,
 doxygen,
 qhelpgenerator-qt5 | qttools5-dev-tools,
 qtbase5-dev,
 libdtkcore-dev
Standards-Version: 4.5.0

Package: libdtkaudiomanager
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Deepin Tool Kit template library
 libdtkaudiomanager is base library of Deepin Qt/C++ applications.
 .
 This package contains the shared libraries.

Package: libdtkaudiomanager-dev
Architecture: any
Depends:${misc:Depends}, libdtkaudiomanager( =${binary:Version})
Description: Deepin Tool Kit template devel library
 libdtkaudiomanager-dev is base devel library of Deepin Qt/C++ applications.
 .
 This package contains the header files and static libraries.
